# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`haveged`](#haveged): Manage the haveged daemon

## Classes

### <a name="haveged"></a>`haveged`

Manage the haveged daemon

#### Examples

##### Declaring the class

```puppet

class { 'haveged':
  write_wakeup_threshold => 2048,
}
```

#### Parameters

The following parameters are available in the `haveged` class:

* [`package_name`](#-haveged--package_name)
* [`package_ensure`](#-haveged--package_ensure)
* [`service_name`](#-haveged--service_name)
* [`service_ensure`](#-haveged--service_ensure)
* [`service_enable`](#-haveged--service_enable)
* [`write_wakeup_threshold`](#-haveged--write_wakeup_threshold)
* [`buffer_size`](#-haveged--buffer_size)
* [`data_cache_size`](#-haveged--data_cache_size)
* [`instruction_cache_size`](#-haveged--instruction_cache_size)

##### <a name="-haveged--package_name"></a>`package_name`

Data type: `String`

The name of the package to manage.  Normally provided by the module's
hiera configuration.  Default: `haveged`

##### <a name="-haveged--package_ensure"></a>`package_ensure`

Data type: `String`

The state of the haveged package.  Valid options: `present`, `installed`,
`absent`, `purged`, `held`, `latest` or a specific package version
number.  Default: `present`

##### <a name="-haveged--service_name"></a>`service_name`

Data type: `String`

The name of the service to manage.  Normally provided by the module's
hiera configuration.  Default: `haveged`

##### <a name="-haveged--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Whether the service should be running.  Normally provided by the module's
hiera configuration.  Default: `running`

##### <a name="-haveged--service_enable"></a>`service_enable`

Data type: `Boolean`

Whether the service should be enabled to start at boot time.  This must
be an boolean value.  Default: `true`

##### <a name="-haveged--write_wakeup_threshold"></a>`write_wakeup_threshold`

Data type: `Integer`

The haveged daemon generates more data if the number of entropy bits
falls below this value.  The value must be a an integer.  Default: `1024`

##### <a name="-haveged--buffer_size"></a>`buffer_size`

Data type: `Optional[Integer]`

The size of the collection buffer.  The value must be a an integer.  It
is interpreted as size in KB.  Default: `128`

Default value: `undef`

##### <a name="-haveged--data_cache_size"></a>`data_cache_size`

Data type: `Optional[Integer]`

The data cache size in KB.  The value must be a an integer.  Default is
`16` or as determined by cpuid.

Default value: `undef`

##### <a name="-haveged--instruction_cache_size"></a>`instruction_cache_size`

Data type: `Optional[Integer]`

The instruction cache size in KB.  The value must be a an integer.
Default is `16` or as determined by cpuid.

Default value: `undef`

